﻿using System;
using System.Collections.Generic;
using System.IO;

namespace graph
{
    public class Graph
    {
        static int[] distance;
        static int?[] previous;
        static HashSet<int> setOfNodes = new HashSet<int>();
      //  public static int FindMinSpanningTree(List<Verge> point, int[] tree, List<Verge> mpd, int treesCount);
     //   public static void SaveTheTree(List<Verge> usedEdges);

        static int Main(string[] args)
        {
            var read = new StreamReader("graph.in");
            int[,] graph=null;
            int[,] afterReconstruction= null;
            int streets = 0;
            int cities = 0;
            List<Verge> point = new List<Verge>();            
            using (read)
            {
                string line = read.ReadLine();
                int counter = 0;

                while (line != null)
                {
                    counter++;
                    string[] curLine = line.Split(' ');

                    if (counter == 1)
                    {
                        cities = int.Parse(curLine[0]);
                        streets = int.Parse(curLine[1]);
                        graph = new int[cities, cities];
                        distance = new int[cities];
                        previous = new int?[cities];
                        afterReconstruction = new int[cities, cities];
                    }
                    else 
                        if (counter <= streets + 1)
                    {
                        int first, second, dist;
                        first = int.Parse(curLine[0]);
                        second = int.Parse(curLine[1]);
                        dist = int.Parse(curLine[2]);
                        point.Add(new Verge(first, second, dist, counter - 1));

                        graph[first - 1, second - 1] = dist;
                        graph[second - 1, first - 1] = dist;

                    }
                    else
                    {
                        for (int i = 0; i < cities; i++)
                        {
                            afterReconstruction[counter - streets - 2, i] = int.Parse(curLine[i]);
                        }
                    }
                    line = read.ReadLine();
                }
            }


            for (int startTown = 1; startTown <= cities; startTown++)
            {
                Trace(graph, startTown - 1);


                for (int i = startTown; i < (int)distance.Length; i++)
                {


                    if (distance[i] != int.MaxValue)
                    {
                        int? indexer = i;
                        int? prevTown = indexer;
                        indexer = previous[indexer.Value];
                        while (indexer != startTown - 1)
                        {
                            foreach (var item in point)
                            {
                                if ((item.FirstNode == prevTown + 1 && item.LastNode == indexer + 1) || (item.FirstNode == indexer + 1 && item.LastNode == prevTown + 1))
                                {
                                    item.Distance *= afterReconstruction[(int)prevTown, (int)indexer];
                                    break;
                                }
                            }
                            prevTown = indexer;
                            indexer = previous[indexer.Value];
                        }

                        foreach (var item in point)
                        {
                            if ((item.FirstNode == prevTown + 1 && item.LastNode == startTown) || (item.FirstNode == startTown && item.LastNode == prevTown + 1))
                            {
                                item.Distance *= afterReconstruction[(int)prevTown, startTown - 1];
                                break;
                            }
                        }
                    }
                }
               
            }


            point.Sort();

            int[] tree = new int[streets + 1];

            List<Verge> mpd = new List<Verge>();
            int treesCount = 1;
            treesCount = FindMinSpanningTree(point, tree, mpd, treesCount);
            SaveTheTree(mpd);

            return 0;
        }


        private static int FindMinSpanningTree(List<Verge> point, int[] tree, List<Verge> mpd, int treesCount)
        {
            foreach (var edge in point)
            {
                if (tree[edge.FirstNode] == 0)
                {
                    if (tree[edge.LastNode] == 0)
                    {
                        tree[edge.FirstNode] = tree[edge.LastNode] = treesCount;
                        treesCount++;
                    }
                    else
                    {
                        tree[edge.FirstNode] = tree[edge.LastNode];
                    }
                    mpd.Add(edge);
                }
                else
                {
                    if (tree[edge.LastNode] == 0)
                    {
                        tree[edge.LastNode] = tree[edge.FirstNode];
                        mpd.Add(edge);
                    }
                    else if (tree[edge.LastNode] != tree[edge.FirstNode]) // combine the trees
                    {
                        int oldTreeNumber = tree[edge.LastNode];

                        for (int i = 0; i < (int)tree.Length; i++)
                        {
                            if (tree[i] == oldTreeNumber)
                            {
                                tree[i] = tree[edge.FirstNode];
                            }
                        }
                        mpd.Add(edge);
                    }
                }
            }
            return treesCount;
        }


        private static void SaveTheTree(List<Verge> usedEdges)
        {
            var writer = new StreamWriter("graph.out");
            using (writer)
            {
                foreach (var edge in usedEdges)
                {
                    writer.WriteLine(edge.Number);
                }
            }
        }


        

        public static void Trace(int[,] graph, int source)
        {
            for (int i = 0; i < graph.GetLength(0); i++)
            {
                distance[i] = int.MaxValue;
                previous[i] = null;
                setOfNodes.Add(i);
            }

            distance[source] = 0;

            while (setOfNodes.Count != 0)
            {
                int minNode = int.MaxValue;

                foreach (var node in setOfNodes)
                {
                    if (minNode > distance[node])
                    {
                        minNode = node;
                    }
                }

                setOfNodes.Remove(minNode);

                if (minNode == int.MaxValue)
                {
                    break;
                }

                for (int i = 0; i < (int)graph.GetLength(0); i++)
                {
                    if (graph[minNode, i] > 0)
                    {
                        int potencialDistance = distance[minNode] + graph[minNode, i];

                        if (potencialDistance < distance[i])
                        {
                            distance[i] = potencialDistance;
                            previous[i] = minNode;
                        }
                    }
                }
            }
        }
    }


    class Verge : IComparable<Verge>
    {
        private int firstNode;
        private int lastNode;
        private int distance;
        private int number;

        public int FirstNode
        {
            get
            {
                return this.firstNode;
            }
            set
            {
                this.firstNode = value;
            }
        }

        public int LastNode
        {
            get
            {
                return this.lastNode;
            }
            set
            {
                this.lastNode = value;
            }
        }

        public int Distance
        {
            get
            {
                return this.distance;
            }
            set
            {
                this.distance = value;
            }
        }

        public int Number
        {
            get
            {
                return this.number;
            }
            set
            {
                this.number = value;
            }
        }

        public Verge(int firstNode, int lastNode, int distance, int number)
        {
            this.FirstNode = firstNode;
            this.LastNode = lastNode;
            this.Distance = distance;
            this.Number = number;
        }

        public int CompareTo(Verge other)
        {
            int weightCompared = (int)this.Distance.CompareTo(other.Distance);

            if (weightCompared == 0)
            {
                return this.FirstNode.CompareTo(other.FirstNode);
            }
            return (int)weightCompared;
        }

    }
}